%define anolis_release 2

%bcond_without check
# https://pagure.io/koji/issue/659
%global debug_package %{nil}

Name:           rust-packaging
Version:        23
Release:        %{anolis_release}%{?dist}
Summary:        RPM macros for building Rust packages
License:        MIT

URL:            https://pagure.io/fedora-rust/rust2rpm
Source:         %{url}/archive/v%{version}/rust2rpm-v%{version}.tar.gz

# https://pagure.io/fedora-rust/rust2rpm/pull-request/221
Patch:          0001-Adjust-build-flags-to-allow-the-new-implementation-u.patch

# patches for backporting upstream bug fixes
Patch:          https://pagure.io/fedora-rust/rust2rpm/c/09a496c.patch
Patch:          https://pagure.io/fedora-rust/rust2rpm/c/1869f5a.patch
Patch:          https://pagure.io/fedora-rust/rust2rpm/c/6a5931b.patch
Patch:          https://pagure.io/fedora-rust/rust2rpm/c/3dec94d.patch
Patch:          https://pagure.io/fedora-rust/rust2rpm/c/d9aa58b.patch
Patch:          https://pagure.io/fedora-rust/rust2rpm/c/b5c64f5.patch

# upstream patch to add support for building with frame pointers:
# https://pagure.io/fedora-rust/rust2rpm/c/c2176f2
# https://pagure.io/fedora-rust/rust2rpm/c/3443c98
Patch:          0002-Add-support-for-conditionally-building-with-frame-po.patch

ExclusiveArch:  %{rust_arches}

BuildRequires:  python3-devel

%if %{with check}
BuildRequires:  cargo
%endif

Requires:       python3-rust2rpm-core = %{EVR}
Requires:       rust-srpm-macros = %{version}

Requires:       rust
Requires:       cargo >= 1.41

# gawk is needed for stripping dev-deps in macro
Requires:       gawk

%description
The package provides RPM macros for building Rust projects.

Note that rust-srpm-macros is a seperate arch-independent package that
is also required to build Rust packages.

%package     -n python3-rust2rpm
Summary:        Generate RPM spec files for Rust packages
Requires:       cargo
Requires:       python3-rust2rpm-core = %{EVR}
Provides:       rust2rpm = %{version}-%{release}

%description -n python3-rust2rpm
rust2rpm is a tool that automates the generation of RPM spec files for
Rust crates.

%package     -n python3-rust2rpm-core
Summary:        Generate RPM spec files for Rust packages (core functionality)
Requires:       cargo
Provides:       cargo-inspector = %{version}-%{release}

%description -n python3-rust2rpm-core
rust2rpm is a tool that automates the generation of RPM spec files for
Rust crates.

This package contains the core functionality which doesn't depend on
any third-party python packages.

%prep
%autosetup -n rust2rpm-v%{version} -p1

%generate_buildrequires
%pyproject_buildrequires -t

%build
%pyproject_wheel

%install
%pyproject_install

install -D -p -m 0644 -t %{buildroot}%{_rpmmacrodir} data/macros.rust data/macros.cargo
install -D -p -m 0644 -t %{buildroot}%{_fileattrsdir} data/cargo.attr

%if %{with check}
%check
%tox
%endif

%files
%{_rpmmacrodir}/macros.rust
%{_rpmmacrodir}/macros.cargo
%{_fileattrsdir}/cargo.attr

%files -n python3-rust2rpm
%{_bindir}/rust2rpm
%{python3_sitelib}/rust2rpm-*.dist-info/
%{python3_sitelib}/rust2rpm/
%exclude %{python3_sitelib}/rust2rpm/core/

%files -n python3-rust2rpm-core
%license LICENSE
%doc README.md NEWS
%{_bindir}/cargo-inspector
%{python3_sitelib}/rust2rpm/core/

%changelog
* Wed Mar 13 2024 Zhao Hang <wb-zh951434@alibaba-inc.com> - 1:23-2
- Rebuild with python3.11
- update Copyright date

* Tue Feb 14 2023 Funda Wang <fundawang@yeah.net> - 1:23-1
- New version 23

* Wed Apr 20 2022 happy_orange <songnannan@linux.alibaba.com> - 1:21-1
- Init package from upstream
